//---------------------------------------------------------------------------
#ifndef CDIRECTSOUNDH
#define CDIRECTSOUNDH
//---------------------------------------------------------------------------

#define DEF_VALUECOUNT            1024*20
#define DEF_SAMPLEPERSEC          11025*9
#define DEF_FRIC                  400
#define DEF_AMP                   0x7FFF

class C_DIRECTSOUND:public ICDIRECTSOUND{
bool Init(void);
bool Uninit(void);
bool SelfDestroy(void);

bool Amp(double _fric);
bool Fric(double _fric);
bool Runing(bool runing);

public:
C_DIRECTSOUND(void);
void Clear(void);
static  DWORD WINAPI ThreadFunc(void *P);
DWORD   RunInterogate(void);
void    Interogate16s(void *bufer,unsigned szbufer);

//  
LPDIRECTSOUND        pds;//=NULL;
LPDIRECTSOUNDBUFFER  prim;//=NULL;
LPDIRECTSOUNDBUFFER  sec;//=NULL;
HANDLE               evento[2];//=NULL;
HANDLE               hthread;//=NULL;
bool                 run;
unsigned             szinbufer;//=0;

unsigned             valuecount;//=DEF_VALUECOUNT;
unsigned             samplepersec;//=DEF_SAMPLEPERSEC;
double               fric;//=DEF_FRIC; 
unsigned             amp;//=DEF_AMP;

bool                 interogate;//=false;

private:

bool wastry;//=false;
bool initok;//=false;
};
//---------------------------------------------------------------------------
#endif


