//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "Unit1.h"

#include "IDirectSound.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
TForm1 *Form1;

double f_min=0.0;
double f_max=0.0;

ICDIRECTSOUND *isound=NULL;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void FloatFilter(char &Key)
{
static char enabled[]={".0123456789+-\b"};
int i;
for(i=0;i<sizeof(enabled);i++)
 {
 if(Key==enabled[i])
  {
  return;
  }
 }
Key=0;
}
//---------------------------------------------------------------------------
double Edit_to_dounle(TEdit *edit)
{
char str[64];
char *endptr=&str[ sprintf(str,"%s",edit->Text.c_str() ) ];
return strtod(str,&endptr);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Edit12KeyPress(TObject *Sender, char &Key)
{
FloatFilter(Key);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{

if( !CreateICDirectSound(&isound) )
  {
  MessageBox(Form1->Handle,"   "," ",
  MB_OK|MB_ICONERROR);
  Form1->Close();
  }
  
if( !isound->Init() )
  {
  MessageBox(Form1->Handle,"   "," ",
  MB_OK|MB_ICONERROR);
  Form1->Close();
  }

Edit2Change(NULL);
Edit1Change(NULL);
Edit12Change(NULL);
//TrackBar5Change(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TrackBar5Change(TObject *Sender)
{
bool *lock;
lock=(bool*)(&Tag);

if(*lock)
  return;
                 
*lock=true;

double pos=TrackBar5->Position;
double v=f_max+pos*(f_min-f_max)/double(TrackBar5->Max);
isound->Fric(v);

char str[32];
sprintf(str,"%+.2lf",v);

Edit12->Text=str;

*lock=false;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Edit12Change(TObject *Sender)
{
UpdatePos();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::UpdatePos(void)
{
bool *lock;
lock=(bool*)(&Tag);

if(*lock)
  return;

*lock=true;

double level=Edit_to_dounle(Edit12);
isound->Fric(level);
double pos=0.0;

if(f_min-f_max==0.0)
  pos=0;
else
  pos=(level-f_max)/((f_min-f_max)/double(TrackBar5->Max));

*lock=true;
TrackBar5->Position=pos;
*lock=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Edit1Change(TObject *Sender)
{
f_max=Edit_to_dounle(Edit1);
UpdatePos();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Edit2Change(TObject *Sender)
{
f_min=Edit_to_dounle(Edit2);
UpdatePos();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormDestroy(TObject *Sender)
{
//  
}
//---------------------------------------------------------------------------




